package CVSClient;

use strict;

sub parse_cvsroot {
  my @cvsroot_parts = split /:/, $_[0];
  if (@cvsroot_parts > 0) {
    my @user_parts = split /\@/, $cvsroot_parts[2];
    return (
      protocol => $cvsroot_parts[1],
      user => $user_parts[0],
      server => $user_parts[1],
      rootdir => $cvsroot_parts[3]
    );
  } else {
    return (
      rootdir => $cvsroot_parts[0]
    );
  }
}

sub cvs_co {
  my ($cvsroot, @files) = @_;
  my $cvs = $::cvspath ? ($::cvspath . "/cvs") : "cvs";
  return system($cvs, "-Q", "-d$cvsroot", "co", @files);
}

sub cvs_co_rev {
  my ($cvsroot, $rev, @files) = @_;
  my $cvs = $::cvspath ? ($::cvspath . "/cvs") : "cvs";
  return system($cvs, "-Q", "-d$cvsroot", "co", "-r$rev", @files);
}

1
