package PatchIterator::PatchFileIterator;

#
# USAGE:
# use PatchIterator::PatchFileIterator;
# my $iterator = new PatchIterator::PatchFileIterator();
# $iterator->target(new DiffPrinter::raw);
# $iterator->iterate("mypatch.patch");
#

use strict;

use PatchIterator::RawPatchIterator;

@PatchIterator::PatchFileIterator::ISA = qw(PatchIterator::RawPatchIterator);

sub new {
  my $class = shift;
  $class = ref($class) || $class;
  my $this  = $class->SUPER::new();
  bless $this, $class;

  return $this;
}

sub iterate {
  my $this = shift;
  my ($filename) = @_;

  open FILE, $filename or die "Could not open $this->{FILENAME}: $!";
  $this->startlines($filename);
  while (<FILE>) {
    $this->rawline($_);
  }
  $this->endlines($filename);
  close FILE;
}

1
