package PatchIterator::PatchStringIterator;

#
# USAGE:
# use PatchIterator::PatchStringIterator;
# my $iterator = new PatchIterator::PatchStringIterator();
# $iterator->target(new DiffPrinter::raw);
# $iterator->iterate("id_for_patch", $variable_containing_all_lines_in_patch);
#

use strict;

use PatchIterator::RawPatchIterator;

@PatchIterator::PatchStringIterator::ISA = qw(PatchIterator::RawPatchIterator);

sub new {
  my $class = shift;
  $class = ref($class) || $class;
  my $this  = $class->SUPER::new();
  bless $this, $class;

  return $this;
}

sub iterate {
  my $this = shift;
  my ($id, $data) = @_;

  $this->startlines($id);
  while (/([^\n]*(\n|$))/) {
    $this->rawline($1);
  }
  $this->endlines($id);
}

1
